package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.LandMarkVersion;
import com.izouma.awesomeadmin.service.LandMarkVersionService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/landMarkVersion")
public class LandMarkVersionController {

    @Autowired
    private LandMarkVersionService landMarkVersionService;

    /**
    * <p>获取全部记录。</p>
    */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(LandMarkVersion record) {
        List<LandMarkVersion> pp = landMarkVersionService.getLandMarkVersionList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getLandMarkVersion", method = RequestMethod.GET)
    @ResponseBody
    public Result getLandMarkVersion(@RequestParam(required = false, value = "id") String id) {
        LandMarkVersion data = landMarkVersionService.getLandMarkVersionById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(LandMarkVersion record) {
        LandMarkVersion data = landMarkVersionService.getLandMarkVersion(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, LandMarkVersion record) {
        Map<String, Object> result = new HashMap<>();

        List<LandMarkVersion> pp =landMarkVersionService.getLandMarkVersionByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(LandMarkVersion record) {
        boolean num = landMarkVersionService.createLandMarkVersion(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateLandMarkVersion(LandMarkVersion record) {
        boolean num = landMarkVersionService.updateLandMarkVersion(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteLandMarkVersion(LandMarkVersion record) {

        boolean num = landMarkVersionService.deleteLandMarkVersion(record);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, LandMarkVersion record) throws Exception {

    List<LandMarkVersion> landMarkVersions = landMarkVersionService.getLandMarkVersionList(record);


        String sheetName = "land_mark_version";
        String titleName = "地标版本数据表";
        String fileName = "地标版本表";
        int columnNumber = 10;
        int[] columnWidth = { 20,  20,  20,  20,  20,  20,  20,  20,  20,  20 };
        String[] columnName = {  "ID" ,   "删除标识" ,   "更新时间" ,   "更新人" ,   "创建时间" ,   "创建人" ,   "地标ID" ,   "版本号" ,   "内容" ,   "备注"  };
        String[][] dataList = new String[landMarkVersions.size()][10];

        for (int i = 0; i < landMarkVersions.size(); i++) {

                        dataList[i][0] = String.valueOf(landMarkVersions.get(i).getId());
                        dataList[i][1] = String.valueOf(landMarkVersions.get(i).getDelFlag());
                        dataList[i][2] = String.valueOf(landMarkVersions.get(i).getUpdateTime());
                        dataList[i][3] = String.valueOf(landMarkVersions.get(i).getUpdateUser());
                        dataList[i][4] = String.valueOf(landMarkVersions.get(i).getCreateTime());
                        dataList[i][5] = String.valueOf(landMarkVersions.get(i).getCreateUser());
                        dataList[i][6] = String.valueOf(landMarkVersions.get(i).getLandMarkId());
                        dataList[i][7] = String.valueOf(landMarkVersions.get(i).getVersion());
                        dataList[i][8] = String.valueOf(landMarkVersions.get(i).getJsonText());
                        dataList[i][9] = String.valueOf(landMarkVersions.get(i).getRemark());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

